package neash;

import neash.display.Stage;
import neash.events.Event;
import neash.events.KeyboardEvent;
import neash.display.DisplayObjectContainer;


#if flash
import flash.events.Event;

typedef Current = flash.display.MovieClip;

#else true

typedef Current = neash.display.Stage;

import nme.Manager;
import nme.Surface;
import nme.Sprite;
import nme.Sound;
import nme.Music;
import nme.Rect;
import nme.Point;
import nme.Timer;

#end


class Lib
{
   var mKilled:Bool;
   static var mMe:Lib;
   public static var current(GetCurrent,null):Current;


#if flash
#else true
   static var mStage:neash.display.Stage;
   var mManager : Manager;
#end

   function new(inName:String,inWidth:Int,inHeight:Int)
   {
      mKilled = false;

#if flash
      // flash.Lib.current.stage.frameRate = 100;
#else true
      mManager = new Manager( inWidth, inHeight, inName, false, "" );
      mStage = new neash.display.Stage(inWidth,inHeight,mManager);
#end
   }

   static public function GetCurrent() : Current
   {
#if flash
      return flash.Lib.current;
#else true
      return mStage;
#end
   }
   static public function SetBackgroundColour(inColour:Int)
   {
#if neko
      mStage.backgroundColor =  inColour;
#end
   }


#if neko
   static public function getTimer() { return neko.Sys.time() * 1000.0; }
#else true
   static public function getTimer() { return flash.Lib.getTimer(); }
#end

#if neko
   static public function GetStage() { return mStage; }
   public function processKeys( key, pressed : Bool,
             ctrl:Bool, alt:Bool, shift:Bool )
   {
      switch key
      {
         case 27: // escape;
            mKilled = true;
         // case 274: 0; // down
         // case 275: 0; // right
         // case 276: 0; // left
         default:
            var event = new KeyboardEvent(
                              pressed ? KeyboardEvent.KEY_DOWN:
                                        KeyboardEvent.KEY_UP,
                               true,false,
                               key, key, 1,
                               ctrl,alt,shift);
            // TODO: Send to focus widget.
            mStage.Broadcast(event);
      }
   }
#end


   function MyRun()
   {
#if flash
      // No need to do anyhting!
#else true
      while(!mKilled)
      {
         // Send frame-enter event
         var event = new Event( Event.ENTER_FRAME );
         mStage.Broadcast(event);


         // Fill our event structure with event information.
         mManager.events();
         var type = mManager.getEventType();
         switch(type)
         {
            case et_keydown:
               var kid = mManager.lastKey();
               if (kid>=97 && kid<=122) kid-=32;
               processKeys( kid, true,
                  mManager.lastKeyCtrl(), mManager.lastKeyAlt(),
                  mManager.lastKeyShift() );
            case et_keyup:
               var kid = mManager.lastKey();
               if (kid>=97 && kid<=122) kid-=32;
               processKeys( kid, false,
                  mManager.lastKeyCtrl(), mManager.lastKeyAlt(),
                  mManager.lastKeyShift() );

            case et_quit:
               mKilled = false;
            default:
         }

         mStage.Render();

         mManager.swapBuffers();


      }
      mManager.close();
#end
   }

   static public function Run() { mMe.MyRun(); }


   public static function Init(inName:String,inWidth:Int,inHeight:Int)
   {
      mMe = new Lib(inName,inWidth,inHeight);
   }

}
